<?php

class Centralpay3dsiframeModuleFrontController extends ModuleFrontController
{
  const VIEWS_TEMPLATE_FRONT = '/views/templates/front/';

  public $module;


    public function __construct()
    {
        $this->controller_type = 'modulefront'; //instead of standard controllers’ front

        $this->module = Module::getInstanceByName(Tools::getValue('module')); // an instance of the module is created
        if (!$this->module->active) {
          Tools::redirect('index'); //if the module is inactive, the user will be redirected to index.php
        }
        $this->page_name = 'module-'.$this->module->name.'-'.Dispatcher::getInstance()->getController(); //for example: module-belvg_storelocator-search

        parent::__construct();
    }



    /**
     * Assign module template
     *
     * @param string $template
     */
   public function setTemplate($template)
    {
        if (Tools::file_exists_cache(_PS_THEME_DIR_.'modules/'.$this->module->name.'/'.$template)) {
          $this->template = _PS_THEME_DIR_ . 'modules/' . $this->module->name . '/' . $template; //if the file with the template is located in the root directory
        }elseif (Tools::file_exists_cache($this->getTemplatePath($template))) {
          $this->template = $this->getTemplatePath($template); //otherwise file in  module_dir/views/templates/front/ should be used
        }else{
            throw new PrestaShopException("Template '$template'' not found"); //if the file is not found, the exception will be thrown
         }
    }

    /**
     * Get path to front office templates for the module
     *
     * @return string
     */
    public function getTemplatePath($template)
    {
        return _PS_MODULE_DIR_.$this->module->name.self::VIEWS_TEMPLATE_FRONT.$template;
    }

    public function postProcess()
    {



    }
    /**
     * Assign template vars related to page content
     * @see FrontController::initContent()
     */
    public function initContent()
    {

        $this->disableColumns();
        parent::initContent();


        $this->context->smarty->assign(
            array(
                'url'=>$this->context->link->getModuleLink('centralpay', '3ds')

            )
        );
        return $this->setTemplate('3dsiframe.tpl');

    }


    protected function getModuleDir($data=null)
    {
        $path = _PS_MODULE_DIR_.$this->module->name.self::VIEWS_TEMPLATE_FRONT;
        if(!is_null($data)){
            return _PS_MODULE_DIR_.$this->module->name.self::VIEWS_TEMPLATE_FRONT.$data.'/';
        }

        if(!is_null($data)) {
          throw new PrestaShopException('Template not mapped');
        }

        return $path;
    }

    protected function disableColumns()
    {
        $this->display_column_left = false;
        $this->display_column_right = false;
        $this->display_footer = true;
        $this->display_header = true;
    }


}